#ifndef EFI_PROTOCOLS_COMPONENT_NAME2_H
#define EFI_PROTOCOLS_COMPONENT_NAME2_H

#define EFI_COMPONENT_NAME2_PROTOCOL_GUID {0x6a7a5cff,0xe8d9,0x4f70, {0xba,0xda,0x75,0xab,0x30,0x25,0xce,0x14}}

typedef struct _EFI_COMPONENT_NAME2_PROTOCOL EFI_COMPONENT_NAME2_PROTOCOL;

typedef
EFI_STATUS
(EFIAPI *EFI_COMPONENT_NAME_GET_DRIVER_NAME)(
	IN EFI_COMPONENT_NAME2_PROTOCOL *This,
	IN CHAR8 *Language,
	OUT CHAR16 **DriverName
);

typedef
EFI_STATUS
(EFIAPI *EFI_COMPONENT_NAME_GET_CONTROLLER_NAME)(
	IN EFI_COMPONENT_NAME2_PROTOCOL *This,
	IN EFI_HANDLE ControllerHandle,
	IN EFI_HANDLE ChildHandle OPTIONAL,
	IN CHAR8 *Language,
	OUT CHAR16 **ControllerName
);

typedef struct _EFI_COMPONENT_NAME2_PROTOCOL {
	EFI_COMPONENT_NAME_GET_DRIVER_NAME GetDriverName;
	EFI_COMPONENT_NAME_GET_CONTROLLER_NAME GetControllerName;
	CHAR8 *SupportedLanguages;
} EFI_COMPONENT_NAME2_PROTOCOL;

#endif /* EFI_PROTOCOLS_COMPONENT_NAME2_H */
